unit Funcs;

interface

uses Kol,Windows;

  procedure BMPInit;
  procedure GenerateImage(N:Integer);


Type

  RRGBA=record
    R,G,B,A:Byte;
  end;

  RPalette=array [0..255] of RRGBA;

  RBMPTemplate=record
    FileHeader:BITMAPFILEHEADER;
    InfoHeader:BITMAPINFOHEADER;
    Palette:RPalette;
  end;

var
  BMPTemplate:RBMPTemplate;

  implementation
  uses MainUnit;

procedure BMPInit;
var
  FPal: PStream;
begin
  with BMPTemplate do
  begin
    FileHeader.bfType:=(ord('B')+ord('M')*256);
    FileHeader.bfReserved1:=0;
    FileHeader.bfReserved2:=0;
    FileHeader.bfOffBits:=SizeOf(BMPTemplate);
    InfoHeader.biSize:=SizeOf(InfoHeader);
    InfoHeader.biPlanes:=1;
    InfoHeader.biBitCount:=8;
    InfoHeader.biCompression:=BI_RGB;
    InfoHeader.biSizeImage:=0;
    InfoHeader.biXPelsPerMeter:=0;
    InfoHeader.biYPelsPerMeter:=0;
    InfoHeader.biClrUsed:=0;
    InfoHeader.biClrImportant:=0;
    FPal:=NewMemoryStream;
    Resource2Stream(FPal,hInstance,'Palette','Palette');
    FPal.Seek($00,spBegin);
    FPal.Read(Palette,SizeOf(Palette));
    FPal.Free;
  end;
end;

procedure GenerateImage(N:Integer);
Type
  RSubCol=record
    Bottom: Word;
    Offset: Word;
    Top: Word;
  end;
var
  OddWidth,RealWidth:Integer;
  BuffIn,BuffOut:array[0..63,0..63] of byte;
  SmallBuff:array[0..63]of byte;
// 
  Word1,Word2,TZero,SCount: Word;
  DataOffset,i,j,SegmentLength: LongInt;
  TMPSubCol:RSubCol;
  ColsEntries: array [0..63] of Word;
  SubColsEntries: array of array of RSubCol;
  z: LongInt;
  TMPOutFile:PStream;
  UseColor:array [0..255] of Boolean;
begin

  For i:=0 to 255 do
    UseColor[i]:=False;
  TMPOutFile:=NewMemoryStream;
  case N of
    0..105:
    begin
      WorkFile.Items[N].Data.Seek($00,spBegin);
      WorkFile.Items[N].Data.Read(BuffIn,TextureSize);
      For i:=0 to TextureWidth-1 do
       For j:=0 to TextureHeight-1 do
       begin
         BuffOut[TextureWidth-1-i,j]:=BuffIn[j,i];
         UseColor[BuffIn[j,i]]:=True;
       end;
      WorkFile.Items[N].Colors:=0;
      For i:=0 to 255 do
        if UseColor[i] then
          Inc(WorkFile.Items[N].Colors);
      with BMPTemplate do
      begin
        FileHeader.bfSize:=SizeOf(BMPTemplate)+64*64;
        InfoHeader.biSize:=SizeOf(InfoHeader);
        InfoHeader.biWidth:=64;
        InfoHeader.biHeight:=64;
        TMPOutFile.Write(BMPTemplate,SizeOf(BMPTemplate));
      end;
      TMPOutFile.Write(BuffOut,TextureSize);
    end;

    106..540:
    begin
      WorkFile.Items[N].Data.Seek($00,spBegin);
      WorkFile.Items[N].Data.Read(Word1,2);
      WorkFile.Items[N].Data.Read(Word2,2);
      //   
      DataOffset:=(Word2-Word1+3)*2;
      //  
      RealWidth:=(DataOffset-4) div 2;
      OddWidth:=RealWidth;
      if OddWidth mod 4<>0 then
      OddWidth:=(RealWidth div 4+1)*4;
      //  
      For i:=0 to RealWidth-1 do
        WorkFile.Items[N].Data.Read(ColsEntries[i],2);
      // 
      FillChar(BuffIn,64*64,$00);
      SetLength(SubColsEntries,RealWidth);
      For i:=0 to RealWidth-1 do
      begin
        WorkFile.Items[N].Data.Seek(ColsEntries[i],spBegin);
        FillChar(SmallBuff,64,$00);
        SCount:=0;
        WorkFile.Items[N].Data.Read(TZero,2);
        If TZero=0 then
          Continue
        Else
          WorkFile.Items[N].Data.Seek(-2,spCurrent);
        repeat
          WorkFile.Items[N].Data.Read(TMPSubCol,SizeOf(TMPSubCol));
          WorkFile.Items[N].Data.Read(TZero,2);
          If TZero<>0 then
            WorkFile.Items[N].Data.Seek(-2,spCurrent);
          Inc(SCount);
          SetLength(SubColsEntries[i],SCount);
          SubColsEntries[i][SCount-1]:=TMPSubCol;
        until (TZero=0);
      end;
      WorkFile.Items[N].Data.Seek(DataOffset,spBegin);
      for i:=0 to RealWidth-1 do
        for j:=0 to High(SubColsEntries[i]) do
        begin
          SegmentLength:=(SubColsEntries[i][j].Bottom-SubColsEntries[i][j].Top) div 2;
          WorkFile.Items[N].Data.Read(SmallBuff,SegmentLength);
          SubColsEntries[i][j].Bottom:=SubColsEntries[i][j].Bottom div 2;
          SubColsEntries[i][j].Top:=SubColsEntries[i][j].Top div 2;
          for z:=0 to SegmentLength-1 do
          begin
            BuffIn[63-(z+SubColsEntries[i][j].Top),i]:=SmallBuff[z];
            UseColor[SmallBuff[z]]:=True;
          end;
        end;
          with BMPTemplate do
          begin
            FileHeader.bfSize:=SizeOf(BMPTemplate)+OddWidth*64;
            InfoHeader.biSize:=SizeOf(InfoHeader);
            InfoHeader.biWidth:=RealWidth;
            InfoHeader.biHeight:=64;
            TMPOutFile.Write(BMPTemplate,SizeOf(BMPTemplate));
          end;
        WorkFile.Items[N].Colors:=0;
      For i:=0 to 255 do
        if UseColor[i] then
          Inc(WorkFile.Items[N].Colors);
        For i:=0 to 63 do
        begin
          TMPOutFile.Write(BuffIn[i],OddWidth);
        end;
    end;
  end;
  TMPOutFile.Seek(0,spBegin);
  WorkFile.Items[N].BM:=NewBitmap(0,0);
  WorkFile.Items[N].BM.LoadFromStream(TMPOutFile);
  TMPOutFile.Free;
end;

end.

